/* This testcase is part of GDB, the GNU debugger.

   Copyright 2013 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

static int
func1 (int a, int b)
{
  int r = a * b;

  r =+ (a | b);
  r =+ (a - b);

  return r;
}

int
main(void)
{
  int a = 0;
  int b = 1;
  int c = 2;
  int d = 3;
  int e = 4;
  double d1 = 1.0;
  double d2 = 2.0;

  /* A line of source will produce multiple number of
     instructions.  */
  a = b + c + d * e - a; /* location 1 */

  /* To compose multiple instructions before and after
     'function call' or 'branch' instruction.  This line
     of source will produce the following instructions,

addr1:
     insn1;
     insn2;
     ...
     call func1;
     ...
     insn3;
addr2:
     insn4;  */
  e = 10 + func1 (a + b, c * d); /* location 2 */

  e = 10 + func1 (a + b, c * d);
  /* Produce a range that includes a loop in it.  */
  for (a = 0, e = 0; a < 15; a++) { e += a;}
  /* Produce a range that includes a loop in it.  */
  for (a = 0, e = 0; a < 15; a++) { e += a;}
  /* Produce a range that includes a loop, which is time consuming.
     Variable C is used to terminate the loop earlier when GDB
     wants.  */
  for (c = 1, a = 0; a < 65535 && c; a++) {for (b = 0; b < 65535 && c; b++) { d1 = d2 * a / b; d2 = d1 * a;}}
  return 0;
}
